/* portdefs.h - definitions for portability */
@@ ENVIRONMENT-DEPENDENT - ADJUST TO LOCAL SYSTEM */
@@ Edit your local changes, then replace each "@@" with "/*" */
#ifndef PORTDEFS_H
#define PORTDEFS_H

/* adjust these names to local machine/compiler environment */
typedef unsigned short ushort;	@@ or "unsigned" if short-size == int-size */
typedef unsigned char utiny;	@@ to get unsigned byte */
typedef int void;				@@ delete if compiler supports void */
typedef unsigned index_t;		@@ may be chosen ad-lib locally */
typedef char *data_ptr;			@@ use ANSI "generic ptr" if available */

/* next 5 names require no local changes, will work anywhere */
typedef char tbits;				/* one byte, for bitwise uses */
typedef char tbool;				/* one byte: {0:1} */
typedef ushort bits;			/* 16 bits (or more), for bitwise uses */			
typedef int bool;				/* for function returns: {0:1} */
typedef short metachar;			/* return from getchar: {EOF,0:UCHAR_MAX} */

/* modulo function giving non-negative result */
#define IMOD(i, j) (((i) % (j)) < 0 ? ((i) % (j)) + (j) : ((i) % (j)))
@@ if i % j is never negative, replace with the following line: */
@@ #define IMOD(i, j) ((i) % (j)) */

/* portably convert unsigned number to signed */
#define UI_TO_I(ui) (int)(ui)	@@ more complicated on ones complement */

/* structure offsets and bounds; adjust to local system */
#define STRICT_ALIGN int		@@ adjust to local alignment requirement */
#define OFFSET(st, m) \
	((char *)&((st *)&struct_addr)->m - (char *)&struct_addr)
#define BOUNDOF(t) \
	((char *)(struct {char byte0; t byten; } *)&struct_addr)->byten - \
	(char *)&struct_addr)
static STRICT_ALIGN struct_addr = 0;
#define STRUCTASST(a, b) memcpy(&(a), &(b), sizeof(a))

/* defined constants */
#define FAIL			1			@@ failure exit */
#define SUCCEED			0			@@ normal exit */
#define STDIN			0			/* standard input */
#define STDOUT			1			/* standard output */
#define STDERR			2			/* standard error output */
#define SEEK_SET		0			/* seek relative to start of file */
#define SEEK_CUR		1			/* seek relative to current position */
#define SEEK_END		2			/* seek relative to end */
#endif
